blob: 36593541818ef2253b140ef604269b5e6b833eaf [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblas7bcadc52020-02-02 22:40:15 +010016RELEASE=ReleaseSEVEN
17REPOSITORY=stable
18DOCKER_TAG=7
garciadeblas93c61312016-09-28 15:12:48 +020019
garciadeblas38d91ee2019-11-07 16:31:23 +010020function usage(){
21 echo -e "usage: $0 [OPTIONS]"
22 echo -e "Install OSM from binaries or source code (by default, from binaries)"
23 echo -e " OPTIONS"
24 echo -e " -r <repo>: use specified repository name for osm packages"
25 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
26 echo -e " -u <repo base>: use specified repository url for osm packages"
27 echo -e " -k <repo key>: use specified repository public key url"
28 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
29 echo -e " -b master (main dev branch)"
30 echo -e " -b v2.0 (v2.0 branch)"
31 echo -e " -b tags/v1.1.0 (a specific tag)"
32 echo -e " ..."
33 echo -e " -s <stack name> user defined stack name, default is osm"
34 echo -e " -H <VCA host> use specific juju host controller IP"
35 echo -e " -S <VCA secret> use VCA/juju secret key"
36 echo -e " -P <VCA pubkey> use VCA/juju public key file"
37 echo -e " -C <VCA cacert> use VCA/juju CA certificate file"
38 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
39 echo -e " --vimemu: additionally deploy the VIM emulator as a docker container"
40 echo -e " --elk_stack: additionally deploy an ELK docker stack for event logging"
beierlm107d16a2020-05-15 21:47:43 -040041 echo -e " --pla: install the PLA module for placement support"
garciadeblas38d91ee2019-11-07 16:31:23 +010042 echo -e " --pm_stack: additionally deploy a Prometheus+Grafana stack for performance monitoring (PM)"
beierlm107d16a2020-05-15 21:47:43 -040043 echo -e " -m <MODULE>: install OSM but only rebuild the specified docker images (LW-UI, NBI, LCM, RO, MON, POL, KAFKA, MONGO, PROMETHEUS, KEYSTONE-DB, PLA, NONE)"
garciadeblas38d91ee2019-11-07 16:31:23 +010044 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (vimemu, elk_stack, pm_stack)"
45 echo -e " -D <devops path> use local devops installation path"
46 echo -e " -w <work dir> Location to store runtime installation"
47 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
beierlm107d16a2020-05-15 21:47:43 -040048 echo -e " -l: LXD cloud yaml file"
49 echo -e " -L: LXD credentials yaml file"
50 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas38d91ee2019-11-07 16:31:23 +010051 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
52 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
53 echo -e " --nojuju: do not juju, assumes already installed"
54 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
55 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
56 echo -e " --nohostclient: do not install the osmclient"
57 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
58 echo -e " --source: install OSM from source code using the latest stable tag"
59 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
60 echo -e " --soui: install classic build of OSM (Rel THREE v3.1, based on LXD containers, with SO and UI)"
61 echo -e " --lxdimages: (only for Rel THREE with --soui) download lxd images from OSM repository instead of creating them from scratch"
62 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
63 echo -e " -l <lxd_repo>: (only for Rel THREE with --soui) use specified repository url for lxd images"
64 echo -e " -p <path>: (only for Rel THREE with --soui) use specified repository path for lxd images"
65 echo -e " --nat: (only for Rel THREE with --soui) install only NAT rules"
66 echo -e " --noconfigure: (only for Rel THREE with --soui) DO NOT install osmclient, DO NOT install NAT rules, DO NOT configure modules"
67 echo -e " --showopts: print chosen options and exit (only for debugging)"
madaviae0784f2020-01-22 16:29:19 +053068 #echo -e " --clean_volumes To clear all the mounted volumes from docker swarm"
garciadeblas38d91ee2019-11-07 16:31:23 +010069 echo -e " -y: do not prompt for confirmation, assumes yes"
70 echo -e " -h / --help: print this help"
Dominik Fleischmann13582a52020-06-04 10:52:05 +020071 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
72 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
73 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
74 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
75 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
76 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
77 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
Dominik Fleischmann9a5b6ee2020-06-09 11:45:08 +020078 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
Dominik Fleischmann13582a52020-06-04 10:52:05 +020079 echo -e " [--tag]: Docker image tag"
80
garciadeblas38d91ee2019-11-07 16:31:23 +010081}
82
garciadeblasd8bc5c32018-05-09 17:37:56 +020083add_repo() {
84 REPO_CHECK="^$1"
85 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
86 if [ $? -ne 0 ]
87 then
garciadeblasbd925e42018-06-14 14:32:12 +020088 need_packages_lw="software-properties-common apt-transport-https"
89 echo -e "Checking required packages: $need_packages_lw"
90 dpkg -l $need_packages_lw &>/dev/null \
91 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
92 || sudo apt-get -q update \
Mike Marchetti34124182018-10-16 08:22:30 -040093 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020094 || exit 1
95 dpkg -l $need_packages_lw &>/dev/null \
96 || ! echo -e "Installing $need_packages_lw requires root privileges." \
97 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -040098 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +020099 || exit 1
garciadeblasd8bc5c32018-05-09 17:37:56 +0200100 wget -qO - $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg | sudo apt-key add -
101 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1" && sudo DEBIAN_FRONTEND=noninteractive apt-get update
garciadeblas429b9f82018-03-20 02:09:44 +0100102 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +0200103 fi
104
105 return 1
garciadeblas55490d42016-10-29 14:22:03 +0200106}
107
garciadeblas25e87d22020-01-31 14:27:29 +0100108clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +0530109dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +0530110if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +0530111 # Clean the previous repos that might exist
112 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
113fi
114}
115
beierlm107d16a2020-05-15 21:47:43 -0400116while getopts ":b:r:c:k:u:R:l:L:K:p:D:o:m:H:S:s:w:t:U:P:A:-: hy" o; do
garciadeblas38d91ee2019-11-07 16:31:23 +0100117 case "${o}" in
garciadeblas38d91ee2019-11-07 16:31:23 +0100118 r)
119 REPOSITORY="${OPTARG}"
120 ;;
121 R)
122 RELEASE="${OPTARG}"
123 ;;
124 u)
125 REPOSITORY_BASE="${OPTARG}"
126 ;;
127 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100128 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100129 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100130 -)
131 [ "${OPTARG}" == "help" ] && usage && exit 0
beierlm107d16a2020-05-15 21:47:43 -0400132 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100133 :)
134 echo "Option -$OPTARG requires an argument" >&2
135 usage && exit 1
136 ;;
137 \?)
138 echo -e "Invalid option: '-$OPTARG'\n" >&2
139 usage && exit 1
140 ;;
141 h)
142 usage && exit 0
143 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100144 *)
145 ;;
146 esac
147done
148
garciadeblas25e87d22020-01-31 14:27:29 +0100149clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200150add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas35f96ae2018-05-23 12:33:36 +0200151sudo DEBIAN_FRONTEND=noninteractive apt-get -q update
152sudo DEBIAN_FRONTEND=noninteractive apt-get install osm-devops
garciadeblasa5e66072019-05-29 12:23:22 +0200153/usr/share/osm-devops/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D /usr/share/osm-devops -t $DOCKER_TAG "$@"